function objDwPrefService() {
	///////////// Private variables /////////////
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var pref = prefService.getBranch(null);
	var dwPref = prefService.getBranch("downloadwith.");

	///////////// Private Methods /////////////
	function getApplicationList() {
		try { 
			return (dwPref.getCharPref("applicationList")); 
		} catch (e) { return ""; }
	}
 
	function setApplicationList(value) {
		dwPref.setCharPref("applicationList",value); 
	}
 
	///////////// Public Methods /////////////
	this.getIdentificationArray = function () {
		var aux = dwPref.getCharPref("applicationList");
		// Remove first ";" 
		aux = aux.replace(/^;/,"");
		// Remove last ";"
		aux = aux.replace(/;$/,"");
		return aux.split(";;");
	}

	this.isApplicattion = function (identification) {
	    var re = new RegExp(";" + identification + ";");
	    return(re.test(getApplicationList()));
	}

	this.getApplicationLabel = function (identification) {
		if (this.isApplicattion(identification)) {
			dwPrefApplication = prefService.getBranch("downloadwith." + identification + ".");
			try {
				return(dwPrefApplication.getCharPref("label"));
			} catch(e) {}
		}
		return "";
	}

	this.getApplicationCommand = function (identification) {
		if (this.isApplicattion(identification)) {
			dwPrefApplication = prefService.getBranch("downloadwith." + identification + ".");
			try {
				return(dwPrefApplication.getCharPref("command"));
			} catch(e) {}
		}
		return "";
	}

	this.getApplicationArguments = function (identification) {
		if (this.isApplicattion(identification)) {
			dwPrefApplication = prefService.getBranch("downloadwith." + identification + ".");
			try {return(dwPrefApplication.getCharPref("arguments"));}
			catch(e) {}
		}
		return "";
	}

	this.setApplication = function (identification,label,command,arguments) {
		if (this.isApplicattion(identification)) {
			var dwPrefApplication = prefService.getBranch("downloadwith." + identification + ".");
			dwPrefApplication.setCharPref("label", label);
			dwPrefApplication.setCharPref("command", command);
			dwPrefApplication.setCharPref("arguments", arguments);
			return true;
		}
		return false;
	}

	this.addApplication = function (identification,label,command,arguments) {
	    if (!this.isApplicattion(identification)) { 
			setApplicationList(getApplicationList()+ ";" + identification + ";");
			dwPrefApplication = prefService.getBranch("downloadwith." + identification + ".");
			dwPrefApplication.setCharPref("label", label);
			dwPrefApplication.setCharPref("command", command);
			dwPrefApplication.setCharPref("arguments", arguments);
			return true;
		}
		return false;
	}

	this.delApplication = function (identification) {
		if (this.isApplicattion(identification)) { 
			dwPrefApplication = prefService.getBranch("downloadwith." + identification + ".");
			dwPrefApplication.deleteBranch("");
			var re = new RegExp(";" + identification + ";");
			setApplicationList(getApplicationList().replace(re,""));
			return true;
	    }
		return false;
	}

	this.init = function() {
		if (window.navigator.platform.toLowerCase().indexOf("win") != -1) {
			/* windows */
			this.addApplication("getright","GetRight","C:\\Programs Files\\GetRight\\getright.exe","[URL]");
		} else {
			/* unix, linux and others */
			this.addApplication("wget","wget","/usr/X11R6/bin/xterm","-hold -T wget -e wget -P ~ [URL]");
		}
	}
}