/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above.

Copyright (C) 2003 Gustavo Bittencourt <g.bitten@bol.com.br>
*/

var dwPrefService = new objDwPrefService();
var applicationIdentification = null;
var applicationLabel = null;
var applicationCommand = null;
var applicationArguments = null;

function initDownloadwithPrefPanel() {
    parent.initPanel('chrome://downloadwith/content/pref/pref-downloadwith.xul');
    initDownloadwithPref();
}

function initDownloadwithPref() {
    application = dwPrefService.getIdentificationArray();
	for (var i = 0; i < application.length; i++) {
		document.getElementById("prefListboxApplication").appendItem(dwPrefService.getApplicationLabel(application[i]),application[i]);
	}
}

function changeSelectedApplication() {
	var i = document.getElementById("prefListboxApplication").selectedIndex;
    if ( i != -1 ) {
    	enableElement("prefDeleteButton");
    	enableElement("prefApplicationLabel");
    	enableElement("prefApplicationCommand");
    	enableElement("prefApplicationArguments");
		applicationIdentification = application[i];
		applicationLabel = dwPrefService.getApplicationLabel(application[i]);
		applicationCommand = dwPrefService.getApplicationCommand(application[i]);
		applicationArguments = dwPrefService.getApplicationArguments(application[i]);
    } else {
    	disableElement("prefDeleteButton");
    	disableElement("prefApplicationLabel");
    	disableElement("prefApplicationCommand");
    	disableElement("prefApplicationArguments");
		applicationIdentification = null;
		dwApplicationPref = null;
		applicationLabel = null;
		applicationCommand = null;
		applicationArguments = null;    
    }
	document.getElementById("prefApplicationCaption").label = applicationLabel;
   	document.getElementById("prefApplicationIdentification").value = applicationIdentification;
   	document.getElementById("prefApplicationLabel").value = applicationLabel;
   	document.getElementById("prefApplicationCommand").value = applicationCommand;
   	document.getElementById("prefApplicationArguments").value = applicationArguments;
}

function changeDownloadwithPrefs() {
	dwPrefService.setApplication(document.getElementById("prefApplicationIdentification").value,
		document.getElementById("prefApplicationLabel").value,
		document.getElementById("prefApplicationCommand").value,
		document.getElementById("prefApplicationArguments").value);
	document.getElementById("prefApplicationCaption").label = document.getElementById("prefApplicationLabel").value;
	document.getElementById("prefListboxApplication").selectedItem.label = document.getElementById("prefApplicationLabel").value;
}

function deleteApplicationPrefs() {
    if (applicationIdentification != null) { 
		if (dwPrefService.delApplication(applicationIdentification)) {
			selectIndex = document.getElementById("prefListboxApplication").selectedIndex;
			document.getElementById("prefListboxApplication").removeItemAt(selectIndex);
			changeSelectedApplication();		
		}
    }
}

function createApplicationPrefs() {
	window.openDialog("chrome://downloadwith/content/pref/downloadwithPrefCreate.xul", 
		"downloadwithPrefCreate",
		"chrome,centerscreen,modal=yes,resizable=yes");
}

function addApplication(identification,label,command,arguments) {
    if (dwPrefService.isApplicattion(identification)) { 
      alert("Application identification '" + identification + "' is already installed"); 
    } else {
 	  dwPrefService.addApplication(identification,label,command,arguments);
      document.getElementById("prefListboxApplication").appendItem(label,identification);
      application = dwPrefService.getIdentificationArray();
   	  changeSelectedApplication();		
    }
}

function enableElement(element) {
	document.getElementById(element).removeAttribute("disabled");
}

function disableElement(element) {
	document.getElementById(element).disabled = "true";
}